diff a/src/hotspot/share/gc/shenandoah/shenandoahSTWMark.hpp b/src/hotspot/share/gc/shenandoah/shenandoahSTWMark.hpp
--- a/src/hotspot/share/gc/shenandoah/shenandoahSTWMark.hpp
+++ b/src/hotspot/share/gc/shenandoah/shenandoahSTWMark.hpp
@@ -24,22 +24,24 @@
 
 #ifndef SHARE_GC_SHENANDOAH_SHENANDOAHSTWMARK_HPP
 #define SHARE_GC_SHENANDOAH_SHENANDOAHSTWMARK_HPP
 
 #include "gc/shenandoah/shenandoahMark.hpp"
+#include "gc/shenandoah/shenandoahRootProcessor.hpp"
 
 class ShenandoahSTWMarkTask;
+class ShenandoahGeneration;
 
 class ShenandoahSTWMark : public ShenandoahMark {
   friend class ShenandoahSTWMarkTask;
 
 private:
   ShenandoahSTWRootScanner      _root_scanner;
   TaskTerminator                _terminator;
   bool                          _full_gc;
 public:
- ShenandoahSTWMark(bool full_gc);
+ ShenandoahSTWMark(ShenandoahGeneration* generation, bool full_gc);
  void mark();
 
 private:
   void mark_roots(uint worker_id);
   void finish_mark(uint worker_id);
